﻿var myDoc = app.activeDocument;
var myTextVars = myDoc.textVariables;

// Собираем список имен переменных (исключая из списка встроенные нередактируемые переменные)
var myTextVarsList = new Array ();
for (i = 0; i < myTextVars.length; i++){
    if(myTextVars[i].variableType != VariableTypes.XREF_PAGE_NUMBER_TYPE &&
        myTextVars[i].variableType != VariableTypes.XREF_CHAPTER_NUMBER_TYPE)
    myTextVarsList.push(myTextVars[i].name);
	}

// Диалоговое окно
    var myDlg = new Window ("dialog", "Поиск переменной", undefined, {closeButton: false});
    // Выпадающий список с именами переменных
    var myList = myDlg.add ("group");
    myList.add ("statictext", undefined, "Выбрать переменную:");
    var choseTextVar = myList.add ("dropdownlist", undefined, myTextVarsList);
    // группа кнопок 
    var myBtn = myDlg.add ("group");
    myBtn.alignment = "right";  
    myBtn.add ("button", undefined, "OK");
    myBtn.add ("button", undefined, "Cancel");
    // проверка нажатия кнопок
    if (myDlg.show () == 1) {
        var var_name = choseTextVar.selection.text;
        } else {exit ();}
 // end Диалоговое окно

var t_var = myTextVars.itemByName(var_name);
 
if (t_var.isValid)
{
    if (t_var.associatedInstances.length == 0)
        alert('Внимание!\nТекстовая переменная с именем «' + var_name + '» не используется в активном документе.');
    else
    {
        for (var i = 0; i < t_var.associatedInstances.length; i++)
        {
            show_it (t_var.associatedInstances[i], i+1, t_var.associatedInstances.length, var_name);
        }     
    }
}
else
    alert ('Внимание!!\nТекстовая переменная с именем «' + var_name + '» не существует.');
 
function show_it ( theObj, i, n, var_name )   
{ 
    myDoc.select (theObj.storyOffset, SelectionOptions.replaceWith, var_name); 
    app.activeWindow.zoomPercentage = 600; 
    var msg = 'Переменная ' + var_name + '\n(' + theObj.resultText + ')\n\n'  + 'Результат ' +  i + '/' + n + '\n\nДальше?';
    var _choice = confirm ( msg ); 
    if (_choice == false)   
        exit ();   
    return app.selection[0];
}